#!/bin/bash
#cifs_update_proxy_cred.sh
#
# Copyright @[2010] Novell, Inc.  All Rights Reserved.
#
# USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE DEVELOPER LICENSE
# AGREEMENT OR OTHER AGREEMENT THROUGH WHICH NOVELL, INC. MAKES THE WORK
# AVAILABLE. THIS WORK MAY NOT BE ADAPTED WITHOUT  NOVELL'S PRIOR WRITTEN
# CONSENT.
#
# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY,FITNESS FOR
# A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  NOVELL, THE AUTHORS OF THE
# WORK, AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY
# CLAIM, DAMAGES, OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT, OR OTHERWISE, ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK
# OR THE USE OR OTHER DEALINGS IN THE WORK.
#
# All rights reserved.

COMPRXUSRLOGFILE=/var/opt/novell/log/proxymgmt/pxymgmt.log

CIFSENC=/etc/opt/novell/cifs/.cifspwd.enc               #Local file where the Proxy User Credentials are stored encrypted if oescredstore is not used to store it.
if [ -n "$OES_CIFS_DATA" ]; then
	OES_DATA2="$OES_CIFS_DATA"
fi
cifsProxyUser=$1                                        #Full DN of Proxy User
cifsPassword=$OES_DATA2                                 #Proxy User Password
user_id=`id -u`
if test $user_id -ne 0
then
	echo "cifs_update_proxy_cred.sh: Only root user can run this script" >> $COMPRXUSRLOGFILE
	echo "cifs_update_proxy_cred.sh: Only root user can run this script"
	exit 1
fi


grep "OCS" /etc/opt/novell/cifs/cifs.conf | grep "yes" >>/dev/null 2>&1
if [ $? == 0 ]
then
	ocs=1
else
	ocs=0
fi

if [ $ocs == 1 ]
then
		/usr/sbin/oescredstore  -s -n novell-cifs -u $cifsProxyUser -p $cifsPassword
		if [ $? != 0 ]
		then
			echo "[CIFS OCS]Failed to store ProxyUser name in OCS, Return value: $?" >> $COMPRXUSRLOGFILE
			echo "Update Proxy Credentials Failed. Check log for more details"
			exit 1
		fi
		/usr/sbin/rcnovell-cifs status 1>&2 > /dev/null
		temp=$?
		if [ $temp != "0" ]; then
			echo "[WARNING]: CIFS is not running. Returned Value: $temp" >> $COMPRXUSRLOGFILE
			exit 0
		else
			/usr/sbin/novcifs -i readproxy
			temp=$?
			if [ $temp != 0 ]
			then
				echo "Failed to update global CIFS Configuration, Return value: $temp" >> $COMPRXUSRLOGFILE
				exit 3
			fi
		fi
fi

if [ $ocs == 0 ]
then
	export OES_DATA2=$cifsPassword

	#echo $OES_DATA2
	echo $cifsProxyUser >  $CIFSENC
	/opt/novell/cifs/bin/encrypt_password
	if [ $? != 0 ]
	then
		echo "Encryption Failed while storing credentials in File, Return value: $?" >> $COMPRXUSRLOGFILE
		echo "Update Proxy Credentials Failed. Check log for more details"
		exit 5
	fi
	/usr/sbin/rcnovell-cifs status 1>&2 > /dev/null
	temp=$?
	if [ $temp != "0" ]; then
		echo "[WARNING]: CIFS is not running. Returned Value: $temp" >> $COMPRXUSRLOGFILE
		exit 0
	else
		/usr/sbin/novcifs -i readproxy
		temp=$?
		if [ $temp != 0 ]
		then
			echo "Failed to update global CIFS Configuration, Return value: $temp" >> $COMPRXUSRLOGFILE
			echo "Update Proxy Credentials Failed. Check log for more details"
			exit 6
		fi
	fi
fi
exit 0
